package cicaprojekt;

import java.util.HashMap;
import java.util.Map;

public class Field extends cicaprojekt.Tile
{
	public static Map<Direction, Tile> testAdjacentTile = new HashMap<Direction, Tile>();
	public static Field testField = new Field();
	private static boolean testAdjTileSet = false;
	private static int recursionLimit = 0;


	public Field() {
		setItemOnTile(new Box());
		adjacentTile = testAdjacentTile;
		setTestAdjacentTile();
	}

	private void setTestAdjacentTile() {
		if(!testAdjTileSet) {
			testAdjacentTile.put(Direction.NORTH, Field.testField);
			testAdjacentTile.put(Direction.EAST, Field.testField);
			testAdjacentTile.put(Direction.SOUTH, Field.testField);
			testAdjacentTile.put(Direction.WEST, Field.testField);
			testAdjTileSet = true;
		}
	}

	@Override
	public void spawnStargate(cicaprojekt.Stargate stargate, Direction direction) {
		if (recursionLimit++ >= 10)
			this.adjacentTile.put(direction, new Wall());
		adjacentTile.get(direction).spawnStargate(stargate, direction);
	}

	public void onEntry() {
	}

	public void onExit() {
	}
}
